import { Message } from './types';
import { Observable } from 'rxjs';
export interface JsonRxServerParams<Ctx = unknown> {
    send: (message: Message) => void;
    call: (name: string, payload: unknown, ctx: Ctx) => Promise<unknown> | Observable<unknown> | Promise<Observable<unknown>>;
    notify: (name: string, payload: unknown, ctx: Ctx) => void;
    maxActiveSubscriptions?: number;
}
export declare class JsonRxServer<Ctx = unknown> {
    private readonly send;
    private call;
    private notify;
    private readonly active;
    private readonly maxActiveSubscriptions;
    constructor({ send, call, notify, maxActiveSubscriptions }: JsonRxServerParams<Ctx>);
    private sendError;
    private onSubscribe;
    private onUnsubscribe;
    private onNotification;
    onMessage(message: Message, ctx: Ctx): void;
}
